% =================================================================
:- pred constr(bool).    
:- mode constr(in).
:- ignore constr/1.
% ===========================================================
% Program
:- pred rev(list(int),list(int)).
:- mode rev(in,out).

rev([],[]).
rev([H|T],R) :-
  rev(T,S). %,
%  snoc(S,H,R). % error missing snoc

:- pred snoc(list(int),int,list(int)). 
:- mode snoc(in,in,out).  
snoc([],X,[X]).
snoc([X|Xs],Y,[X|Zs]) :-
  snoc(Xs,Y,Zs).
% ===========================================================
% Catamorphism
:- pred length(list(int),int).
:- mode length(in,out).    
:- cata length/2-1.

length([],L) :- constr(L=0).
length([H|T],L) :-
  constr( L=(LT+1) ),
  length(T,LT).
% ==================================================

% verification
:- pred ff1.
ff1 :-
  constr( ~(L1=L2) ), 
  length(L,L1),
	rev(L,R),
  length(R,L2).

:- pred ff2.
ff2 :-
      constr(~( LC=(LA+1) )),
      length(A,LA), length(C,LC),
      snoc(A,B,C).
  
% ==========================================================
:- query ff1/0.
:- query ff2/0.
% ==========================================================


